classdef discon_man < handle

    properties
        d_vs
        branches
        obs_man
        discon_res % disconnection results
        discon_obss
    end
    
    methods
        function obj=discon_man(v_ref,branches)
            obj.d_vs=v_ref^2*ones(numel(branches),1);
            obj.branches=branches;
            obj.discon_res.t=0;
            obj.discon_res.discon=false([numel(obj.branches),1]);
        end
        
        function initial_discon_obss(obj,dis_para)
            obj.discon_obss.connection=false([numel(obj.obs_man.obss),1]);
            obj.discon_obss.interval=dis_para.d_int;
        end
        
        function var=discon_var(obj,var,discon)
            nd=numel(discon);
            for i=1:nd
                if discon(i)
                    bri=obj.branches{i};
                    idx=bri.idx;
                    %var(idx.vs)=obj.d_vs(i);
                    var(idx.P)=0;
                    var(idx.Q)=0;
                    var(idx.q)=0;
                end
            end
        end
        
        function u=discon_u(obj,u,discon)
            nd=numel(discon);
            for i=1:nd
                if discon(i)
                    bri=obj.branches{i};
                    idx=bri.idx;
                    %u(idx.v_ref)=0;
                    u(idx.pg)=0;
                    u(idx.pc)=0;
                    u(idx.qc)=0;
                end
            end
        end
        
        function g=discon_pow(obj,g,var,nef,discon)
            for i=1:nef
                if discon(i)
                    brii=obj.branches{i};
                    g(i)=var(brii.idx.P);
                    g(i+nef)=var(brii.idx.Q);
                end
            end
        end
        
        function g=discon_vol(obj,g,var_dis,u,nef,discon)
            nd=numel(discon);
            for i=1:nd
                if discon(i)
                    brii = obj.branches{i};
                    P=u(brii.idx.pg)-u(brii.idx.pc);
                    Q=var_dis(brii.idx.q)-u(brii.idx.qc);
                    R=brii.R; X=brii.X;
                    b=beta_PQ(R,X,P,Q);
                    if isempty(b)
                        b=0;
                    end
                    var=var_dis(brii.idx.vs);
                    g(2*nef+i)=var-obj.d_vs(i)-b;
                end
            end
        end
        
        function what=discon_obs(obj,what,discon)
            obsb=numel(obj.obs_man.obss);
            for i=1:obsb
                obsi=obj.obs_man.obss{i};
                ob_area=cell2mat(obsi.ob_branches_area);
                idx_discon=find(discon==true);
                if any(ismember(ob_area,idx_discon))
                    what(obsi.idx.x)=0;
                    what(obsi.idx.y)=0;
                    what(obsi.idx.xhat)=0;
                    what(obsi.idx.zhat)=0;
                end
            end
        end
    end
    
end

function b = beta_PQ(R,X,P,Q)
b=2*(R*P+X*Q);
end

