%% Seed
s = RandStream('mt19937ar','seed',0);
RandStream.setGlobalStream(s);
stream = RandStream.getGlobalStream;


%% parameters of net

% error feedback
net_para.error_feedback=true;
%net_para.error_feedback=false;

% attack
net_para.a_para.attack_ex=true;
%net_para.a_para.attack_ex=false;
net_para.a_para.attack_t=1; % time of attack
net_para.a_para.attack_amp=1e-4; % amplitude of attack
net_para.a_para.bnum=9;

% disconnection
net_para.d_para.d_int=Inf; % interval for decision making
%net_para.dis_int=500;
%net_para.d_para.d_type='detection';
net_para.d_para.d_type='time';
net_para.d_para.d_t=Inf;
net_para.d_para.d_t=5;
net_para.d_para.d_sys=[3;4;5;8;9;10];



%% network construction
nets = [];
nets = [nets;EU_network(net_para)];
%net_para.d_para.d_t=5;
%nets = [nets;EU_network(net_para)];


%% simulation
eqi = nets(1).eq_compute();
t = [0:nets(1).t_int:20]';
init_noise = zeros(numel(eqi),1);
init_noise(nets(1).obs_man.idx.xhat)=noise_amp*ones(numel(nets(1).obs_man.idx.xhat),1);
for i=1:numel(nets)
    nets(i).simulate(t,eqi+init_noise);
end


%% plot
pl_man = plot_man(nets);
pl_man.pplot();