classdef plot_man < handle
    
    properties
        nets
        flags
    end
    
    methods
        
        function obj=plot_man(nets)
            obj.nets=nets;
            
            %flags.v=false;
            flags.v=true;
            
            flags.vshat=false;
            %flags.vshat=true;
            
            flags.vs_error=false;
            %flags.vs_error=true;
            
            flags.P=false;
            %flags.P=true;
            
            flags.Q=false;
            %flags.Q=true;
            
            flags.q=false;
            %flags.q=true;
            
            flags.xhat=false;
            %flags.xhat=true;
            
            flags.zhat=false;
            flags.u=false;
            
            flags.w=false;
            %flags.w=true;
            
            flags.what=false;
            %flags.what=true;
            
            flags.w_error=false;
            %flags.w_error=true;
            
            %flags.q_error=false;
            flags.q_error=true;
            
            obj.flags=flags;
        end
        
        function pplot(obj)
            for i=1:numel(obj.nets)
                net=obj.nets(i);
                t=net.sigs.t;
                sigs=net.sigs;
                if obj.flags.v
                    %{
                    pl_st(t,sqrt(sigs.vs));
                    ylabel('${\rm v}$ [V]','Fontsize',20,'interpreter','latex');
                    %}

                    pl_st(t,sqrt(sigs.vs(:,6:10))); %ylim([215,235]);
                    ylabel('${\rm v}$ [V]','Fontsize',20,'interpreter','latex');
                    legend({'${\rm v}_1$','${\rm v}_2$','${\rm v}_3$','${\rm v}_4$','${\rm v}_5$'},'interpreter','latex','location','southwest');
                end
                if obj.flags.vshat
                    pl_st(t,sqrt(sigs.vshat));
                    ylabel('$\hat{{\rm v}}$ [V]','Fontsize',20,'interpreter','latex');
                end
                if obj.flags.vs_error
                    e_v=sqrt(sigs.vs)-sqrt(sigs.vshat);
                    pl_st(t,e_v(:,6:10));
                    ylabel('$e_{\rm v}$ [V]','Fontsize',20,'interpreter','latex');
                end
                if obj.flags.P
                    pl_st(t,sigs.P);
                    ylabel('$P$','Fontsize',20,'interpreter','latex');
                end
                if obj.flags.Q
                    pl_st(t,sigs.Q);
                    ylabel('$Q$','Fontsize',20,'interpreter','latex');
                end
                if obj.flags.q
                    pl_st(t,sigs.q);
                    ylabel('$q_g$','Fontsize',20,'interpreter','latex');
                end
                if obj.flags.xhat
                    pl_st(t,sigs.xhat);
                    ylabel('$\hat{x}$','Fontsize',20,'interpreter','latex');
                end
                if obj.flags.zhat
                    pl_st(t,sigs.zhat);
                    ylabel('$\hat{z}$','Fontsize',20,'interpreter','latex');
                end
                if obj.flags.w
                    pl_st(t,sigs.w);
                    ylabel('$w$','Fontsize',20,'interpreter','latex');
                end
                if obj.flags.what
                    pl_st(t,sigs.what);
                    ylabel('$\hat{w}$','Fontsize',20,'interpreter','latex');
                end
                if obj.flags.w_error
                    w=sigs.w;what=sigs.what;
                    pl_st(t,w-what);
                    ylabel('$e_w$','Fontsize',20,'interpreter','latex');
                end
                if obj.flags.q_error
                    
                    pl_st(t,sigs.q_e);
                    ylabel('$e_q$','Fontsize',20,'interpreter','latex');
                    
                    % normalized one
                    %{
                    pl_st(t,sigs.q_e_nom(:,4));
                    ylabel('$e_q$','Fontsize',20,'interpreter','latex');
                    %}
                end
            end
        end
        
    end
    
end

function pl_st(t,x)
    figure; hold on; grid on;
    plot(t,x,'Linewidth',1);
    set(gca,'Fontsize',20);
    xlabel('$t$ [sec]','Fontsize',20,'interpreter','latex');
    %ylabel('response','Fontsize',20);
end